'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _reactAddonsPureRenderMixin = require('react-addons-pure-render-mixin');

var _reactAddonsPureRenderMixin2 = _interopRequireDefault(_reactAddonsPureRenderMixin);

var _formsyReact = require('./formsy-react');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _ControlWrapper = require('./ControlWrapper');

var _ControlWrapper2 = _interopRequireDefault(_ControlWrapper);

var _ControlMixin = require('./ControlMixin');

var _ControlMixin2 = _interopRequireDefault(_ControlMixin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_VALUE = [];

exports.default = (0, _createReactClass2.default)({
  displayName: 'CheckboxGroup',

  propTypes: {
    className: _propTypes2.default.string,
    onChange: _propTypes2.default.func,
    options: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object]),
    value: _propTypes2.default.arrayOf(_propTypes2.default.string)
  },

  getDefaultProps: function getDefaultProps() {
    return { value: DEFAULT_VALUE, options: [] };
  },


  mixins: [_formsyReact2.default.Mixin, _ControlMixin2.default, _reactAddonsPureRenderMixin2.default],

  /**
   * Render checkboxes.
   *
   * @returns {ReactElement[]}
   */

  renderCheckboxes: function renderCheckboxes() {
    return this.getOptions().map(this.renderCheckbox);
  },


  /**
   * Render checkbox input.
   *
   * @returns {ReactElement}
   */
  renderCheckbox: function renderCheckbox(entry, index) {
    var className = this.props.className;

    var checked = this.props.value === DEFAULT_VALUE || this.props.value === null ? null : this.props.value.indexOf(entry.value) !== -1;
    var props = _extends({}, this.getControlProps(), {
      id: null,
      className: className === 'form-control' ? null : className,
      value: entry.value,
      type: 'checkbox',
      checked: checked,
      ref: index,
      onChange: this.onChange
    });
    return _react2.default.createElement(
      'label',
      { className: 'checkbox-inline', key: index },
      _react2.default.createElement('input', props),
      entry.label
    );
  },


  /**
   * Called when the value changes.
   *
   * @param {SyntheticEvent} event
   */

  onChange: function onChange() {
    var _this = this;

    var value = this.getOptions().reduce(function (value, option, index) {
      if (_this.refs[index].checked) value.push(option.value);
      return value;
    }, []);
    this.changeValue(value);
  },
  render: function render() {
    return _react2.default.createElement(
      _ControlWrapper2.default,
      this.getWrapperProps(),
      this.renderCheckboxes()
    );
  }
});