'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _reactAddonsPureRenderMixin = require('react-addons-pure-render-mixin');

var _reactAddonsPureRenderMixin2 = _interopRequireDefault(_reactAddonsPureRenderMixin);

var _formsyReact = require('./formsy-react');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _ControlWrapper = require('./ControlWrapper');

var _ControlWrapper2 = _interopRequireDefault(_ControlWrapper);

var _ControlMixin = require('./ControlMixin');

var _ControlMixin2 = _interopRequireDefault(_ControlMixin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _createReactClass2.default)({
  displayName: 'Input',

  propTypes: {
    autoCorrect: _propTypes2.default.string,
    autoComplete: _propTypes2.default.string,
    autoCapitalize: _propTypes2.default.string,
    autoFocus: _propTypes2.default.bool,
    maxLength: _propTypes2.default.number,
    placeholder: _propTypes2.default.string,
    leftAddon: _propTypes2.default.node,
    rightAddon: _propTypes2.default.node,
    type: _propTypes2.default.string
  },

  getDefaultProps: function getDefaultProps() {
    return {
      type: 'text'
    };
  },


  mixins: [_formsyReact2.default.Mixin, _ControlMixin2.default, _reactAddonsPureRenderMixin2.default],

  /**
   * Called when the value changes.
   *
   * @param {SyntheticEvent} event
   */

  onChange: function onChange(event) {
    this.changeValue(event.target.value);
  },
  render: function render() {
    var _props = this.props,
        autoCapitalize = _props.autoCapitalize,
        autoCorrect = _props.autoCorrect,
        autoComplete = _props.autoComplete,
        autoFocus = _props.autoFocus,
        maxLength = _props.maxLength,
        placeholder = _props.placeholder,
        type = _props.type,
        leftAddon = _props.leftAddon,
        rightAddon = _props.rightAddon;
    var onChange = this.onChange;

    var controlProps = _extends({}, this.getControlProps(), {
      autoCapitalize: autoCapitalize,
      autoCorrect: autoCorrect,
      autoComplete: autoComplete,
      autoFocus: autoFocus,
      maxLength: maxLength,
      placeholder: placeholder,
      onChange: onChange,
      type: type
    });
    var wrapperProps = _extends({}, this.getWrapperProps(), {
      hasAddon: Boolean(this.props.leftAddon || this.props.rightAddon)
    });

    return _react2.default.createElement(
      _ControlWrapper2.default,
      wrapperProps,
      leftAddon ? _react2.default.cloneElement(leftAddon, { control: this }) : null,
      _react2.default.createElement('input', controlProps),
      rightAddon ? _react2.default.cloneElement(rightAddon, { control: this }) : null
    );
  }
});