'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _reactAddonsPureRenderMixin = require('react-addons-pure-render-mixin');

var _reactAddonsPureRenderMixin2 = _interopRequireDefault(_reactAddonsPureRenderMixin);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _formsyReact = require('./formsy-react');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _ControlWrapper = require('./ControlWrapper');

var _ControlWrapper2 = _interopRequireDefault(_ControlWrapper);

var _ControlMixin = require('./ControlMixin');

var _ControlMixin2 = _interopRequireDefault(_ControlMixin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _createReactClass2.default)({
  displayName: 'Select',

  propTypes: {
    onChange: _propTypes2.default.func,
    options: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object]),
    placeholder: _propTypes2.default.string
  },

  getDefaultProps: function getDefaultProps() {
    return { options: [] };
  },


  mixins: [_formsyReact2.default.Mixin, _ControlMixin2.default, _reactAddonsPureRenderMixin2.default],

  /**
   * Render placeholder.
   *
   * @returns {ReactElement}
   */

  renderPlaceHolder: function renderPlaceHolder() {
    var placeholder = this.props.placeholder;


    if (!placeholder) return null;

    return _react2.default.createElement(
      'option',
      { value: '' },
      placeholder
    );
  },


  /**
   * Render options.
   *
   * @returns {ReactElement[]}
   */

  renderOptions: function renderOptions() {
    return this.getOptions().map(this.renderOption);
  },


  /**
   * Render option.
   *
   * @returns {ReactElement}
   */

  renderOption: function renderOption(entry, index) {
    var props = {
      key: index,
      value: entry.value,
      ref: index
    };
    return _react2.default.createElement(
      'option',
      props,
      entry.label
    );
  },


  /**
   * Called when the value changes.
   *
   * @param {SyntheticEvent} event
   */

  onChange: function onChange(event) {
    this.changeValue(event.target.value);
  },
  render: function render() {
    var onChange = this.onChange;


    var controlProps = this.getControlProps();
    var className = (0, _classnames2.default)(controlProps.className, { placeholder: !this.getValue() });

    return _react2.default.createElement(
      _ControlWrapper2.default,
      this.getWrapperProps(),
      _react2.default.createElement(
        'select',
        _extends({}, controlProps, { onChange: onChange, className: className }),
        this.renderPlaceHolder(),
        this.renderOptions()
      )
    );
  }
});